明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 2118|回复: 4

奇怪的添加块参照问题

[复制链接]
发表于 2010-7-9 09:18:00 | 显示全部楼层 |阅读模式

我对已有的一个块添加相应一个块参照,插入点由提示PromptPointOptions获取,但是插入后并不显示在那个点位置,而是有很大偏差,高手们帮我看看啊,谢谢

Dim ed As Editor = AcadApp.DocumentManager.MdiActiveDocument.Editor
        Dim db As Database = AcadApp.DocumentManager.MdiActiveDocument.Database
        ' 普通的点交互操作.
        Dim optPoint As New PromptPointOptions(vbCrLf & "请指定放置点:")
        Dim resPoint As PromptPointResult = ed.GetPoint(optPoint)
        If resPoint.Status <> PromptStatus.OK Then Return ObjectId.Null
        Dim obid As ObjectId
        Using trans As Transaction = db.TransactionManager.StartTransaction()
            ' 将块参照加入到图形数据库中.
            '以读的方式打开块表
            Dim bt As BlockTable = trans.GetObject(db.BlockTableId, OpenMode.ForRead)
            '如果没有blockName表示的块,则程序返回
            If (bt.Has(blockname) = False) Then
                Return ObjectId.Null
            End If
            '以读的方式打开blockName表示的块
            'Dim block As BlockTableRecord = trans.GetObject(bt(blockname), OpenMode.ForRead)
            '创建一个块参照并设置插入点
            Dim mt As Matrix3d = ed.CurrentUserCoordinateSystem
            Dim p3 As Point3d = resPoint.Value.TransformBy(mt)
            Dim blockref As BlockReference = New BlockReference(p3, bt(blockname))
            'Dim blockref As BlockReference = New BlockReference(resPoint.Value, bt(blockname))
            'blockref.ScaleFactors = New Scale3d(1) '设置块参照的缩放比例
            'blockref.Rotation = 0.5 * Math.PI
            '以写的方式打开当前空间(模型空间或图纸空间)
            Dim btr As BlockTableRecord = trans.GetObject(db.CurrentSpaceId, OpenMode.ForWrite)
            obid = btr.AppendEntity(blockref) '在当前空间加入创建的块参照
            '通知事务处理加入创建的块参照
            trans.AddNewlyCreatedDBObject(blockref, True)
            trans.Commit() '提交事务处理以实现块参照的真实加入
        End Using
        Return obid

发表于 2010-7-9 10:01:00 | 显示全部楼层

1,检查你的块定义插入点位置是否合适

2,试试把自动捕捉关掉后有没有变化

 楼主| 发表于 2010-7-9 11:55:00 | 显示全部楼层
说的太专业了,能不能具体点啊谢谢
发表于 2010-7-9 13:41:00 | 显示全部楼层

把你的包含块的dwg贴上吧

 楼主| 发表于 2010-7-15 17:16:00 | 显示全部楼层
哪位高手帮帮忙啊,急死了
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 23:23 , Processed in 0.171551 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表